<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 1.0
 * @author davidhs
 * @copyright 2013 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

// Admin area settings
function CustomBlocksSettings($return_config = false)
{
	global $txt, $scripturl, $context, $modSettings;

	$position_array = array('header', 'footer');

	$cb_type_array2 = array('bbc', 'php');
	$cb_type_array = array();
	$cb_type_array[] = array('', $txt['cb_type_html']);
	foreach ($cb_type_array2 as $cb_type)
		$cb_type_array[] = array($cb_type, $txt['cb_type_' . $cb_type]);

	$cb_permissions_array2 = array('guest' => 'guests', 'user' => 'users');
	$cb_permissions_array = array();
	$cb_permissions_array[] = array('', $txt[190]);
	foreach ($cb_permissions_array2 as $cb_permissions1 => $cb_permissions2)
		$cb_permissions_array[] = array($cb_permissions1, $txt[$cb_permissions2]);

	$config_vars = array();
	foreach ($position_array as $pos)
	{
		$config_vars[] = $txt['cb_' . $pos];
		$config_vars[] = array('int', 'cb_' . $pos . '_number', null, $txt['cb_' . $pos . '_number']);
		if (!empty($modSettings['cb_' . $pos . '_number']))
			for ($i = 0; $i < $modSettings['cb_' . $pos . '_number']; $i++)
			{
				$pos_i = $pos . '_' . $i;
				$config_vars[] = '';
				$config_vars[] = array('text', 'cb_' . $pos_i . '_name', null, $txt['cb_name']);
				$config_vars[] = array('select', 'cb_' . $pos_i . '_type', $cb_type_array, $txt['cb_type']);
				if ('footer' == $pos)
					$config_vars[] = array('large_text', 'cb_' . $pos_i . '_content', 3, $txt['cb_footer_content']);
				else
					$config_vars[] = array('large_text', 'cb_' . $pos_i . '_content', 3, $txt['cb_content']);
				$config_vars[] = array('int', 'cb_' . $pos_i . '_order', null, $txt['cb_order']);
				$config_vars[] = array('select', 'cb_' . $pos_i . '_permissions', $cb_permissions_array, $txt['cb_permissions']);
			}
	}

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=featuresettings;sa=cb');
	}

	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=cb';
	$context['settings_title'] = $txt['cb'];

	prepareDBSettingContext($config_vars);
}


?>