<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 1.0
 * @author davidhs
 * @copyright 2013 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

// Adds admin area
function cb_admin_area($admin_areas)
{
	global $txt;

	$admin_areas['config']['areas']['modsettings']['subsections']['cb'] = array($txt['cb']);
}

// Adds modify modification
function cb_modify_modification($subActions)
{
	$subActions['cb'] = 'CustomBlocksSettings';
}

// Admin area settings
function CustomBlocksSettings($return_config = false)
{
	global $txt, $scripturl, $context, $modSettings;

	$position_array = array('header', 'footer');

	$cb_type_array2 = array('bbc', 'php');
	$cb_type_array = array();
	$cb_type_array[] = array('', $txt['cb_type_html']);
	foreach ($cb_type_array2 as $cb_type)
		$cb_type_array[] = array($cb_type, $txt['cb_type_' . $cb_type]);

	$cb_permissions_array2 = array('guest' => 'guests', 'user' => 'users');
	$cb_permissions_array = array();
	$cb_permissions_array[] = array('', $txt['all']);
	foreach ($cb_permissions_array2 as $cb_permissions1 => $cb_permissions2)
		$cb_permissions_array[] = array($cb_permissions1, $txt[$cb_permissions2]);

	$config_vars = array();
	$config_vars[] = array('title', 'cb');
	foreach ($position_array as $pos)
	{
		$config_vars[] = array('title', 'cb_' . $pos);
		$config_vars[] = array('int', 'cb_' . $pos . '_number', null, $txt['cb_number'], 'onchange' => 'this.form.submit();', 'subtext' => $txt['cb_' . $pos . '_number_desc']);
		if (!empty($modSettings['cb_' . $pos . '_number']))
			for ($i = 0; $i < $modSettings['cb_' . $pos . '_number']; $i++)
			{
				$pos_i = $pos . '_' . $i;
				$config_vars[] = '';
				$config_vars[] = array('text', 'cb_' . $pos_i . '_name', null, $txt['cb_name']);
				$config_vars[] = array('select', 'cb_' . $pos_i . '_type', $cb_type_array, $txt['cb_type']);
				if ('footer' == $pos)
					$config_vars[] = array('large_text', 'cb_' . $pos_i . '_content', null, $txt['cb_content'], 'size' => 3, 'subtext' => $txt['cb_footer_content_desc']);
				else
					$config_vars[] = array('large_text', 'cb_' . $pos_i . '_content', null, $txt['cb_content'], 'size' => 3);
				$config_vars[] = array('int', 'cb_' . $pos_i . '_order', null, $txt['cb_order']);
				$config_vars[] = array('select', 'cb_' . $pos_i . '_permissions', $cb_permissions_array, $txt['cb_permissions']);
			}
	}

	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=cb';

	// No removing this line you, dirty unwashed mod authors. :p
	if (empty($config_vars))
	{
		$context['settings_save_dont_show'] = true;
		$context['settings_message'] = '<div class="centertext">' . $txt['modification_no_misc_settings'] . '</div>';

		return prepareDBSettingContext($config_vars);
	}

	// Saving?
	if (isset($_GET['save']))
	{
		checkSession();
		$save_vars = $config_vars;
		saveDBSettings($save_vars);
		redirectexit('action=admin;area=modsettings;sa=cb');
	}

	prepareDBSettingContext($config_vars);
}

?>