<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 1.0
 * @author davidhs
 * @copyright 2013 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

// Shows blocks
function cb_template($pos)
{
	global $context, $modSettings;

	$copyright = false;
	$blocks = array();
	for ($i = 0; $i < $modSettings['cb_' . $pos . '_number']; $i++)
	{
		$pos_i = $pos . '_' . $i;
		$permissions = empty($modSettings['cb_' . $pos_i . '_permissions']) ? '' : $modSettings['cb_' . $pos_i . '_permissions'];
		switch ($permissions)
		{
			case 'guest':
				$show = !$context['user']['is_logged'];
				break;
			case 'user':
				$show = $context['user']['is_logged'];
				break;
			default: // all
				$show = true;
				break;
		}
		if ($show)
		{
			$order = empty($modSettings['cb_' . $pos_i . '_order']) ? 0 : $modSettings['cb_' . $pos_i . '_order'];
			$order = (100 * $order) + $i;
			$type = empty($modSettings['cb_' . $pos_i . '_type']) ? '' : $modSettings['cb_' . $pos_i . '_type'];
			if (!empty($modSettings['cb_' . $pos_i . '_content']))
			{
				$blocks[$order] = array($type, $modSettings['cb_' . $pos_i . '_content']);
				if ('footer' == $pos && !$copyright)
					$copyright = !(false === strpos($blocks[$order][1], "{COPYRIGHT}"));
			}
		}
	}

	ksort($blocks);

	if ('footer' == $pos && !$copyright)
		array_unshift($blocks, array('', '<div style="float: center;">{COPYRIGHT}</div>'));

	if ('footer' == $pos)
	{
		ob_start();
		theme_copyright();
		$text_copyright = ob_get_contents();
		$trans = array('{COPYRIGHT}' => $text_copyright);
		ob_end_clean();
	}
	foreach ($blocks as $block)
	{
		$content = $block[1];
		switch ($block[0])
		{
			case 'bbc':
				$content = parse_bbc(censorText($content));
				if ('footer' == $pos)
					$content = strtr($content, $trans);
				echo $content;
				break;
			case 'php':
				if ('footer' == $pos)
					$content = strtr($content, $trans);
				$content = trim(un_htmlspecialchars($content));
				if (substr($content, 0, 5) == '<?php')
					$content = substr($content, 5);
				if (substr($content, -2) == '?>')
					$content = substr($content, 0, -2);
				eval($content);
				break;
			default: // html
				if ('footer' == $pos)
					$content = strtr($content, $trans);
				echo un_htmlspecialchars($content);
		}
	}
}

?>